#链接类型的修改
所有通用的按钮的js都存放在platform/actions下
1. js名称：BaseLinkEditAction
2. 功能作用。
   - 支持定义UI上下文来展示页面，也支持直接定义表单来展示页面
   - 默认为保存和取消按钮，保存的路径为默认，但是可以通过参数配置来替换
3. 参数的使用
    |参数名字|参数说明|参数示例|
    |:--:|:--:|:--:|
    |type|to端的业务类型||
    |linkType|链接类型||
    |form|表单的英文名字|如果设置了form就不显示UI上下文。获取表单的路径为webUIController/getFormDefineById。btmType: 链接类型，值是按钮的参数中的linkType；id: 表单的英文名称，值是按钮的参数中的form|
    |content|UI上下文的名字，优先级小于form|
    |direction|是否反向|positive,p,false三个值都表示false;true表示是选择的to端的数据，然后添加from端的数据|
    |url|后台保存的url|默认为uiDataController/linkEditSave|
    |method|请求后台的方法|默认为post|
    |backPath|后台的服务名字|默认为兼容性为true时等于path,否则为objectServicePath。即configData.compatibility?path:configData.objectServicePath|
    |postSourceData|保存的时候是否发送来源数据|默认为false|
    |postSelectData|保存的时候是否发送选择数据|默认为false|
    |title|窗口的标题|form不为空则使用form的标题；否则使用UI上下文的时必须要配置.支持${xxx}和sourceData.${xxx}表达式|
    |width|窗口的宽度|默认是由layer自适应的|
    |height|窗口的高度|默认是由layer自适应的|
    |hiddenButton|是否隐藏保存和取消按钮，boolean类型，|在配置content的时候，在UI定义上已经包含了保存和取消按钮的时候，需要隐藏默认的按钮|
    |   |文件上传| |
    |uploadFileUrl| 文件上传的路径|默认为vciFileUploadController/uploadFile|
    |uploadFileBackPath|文件上传的服务名称| 默认为兼容性为true时等于path，否则为fileServicePath|
    |uploadAttachment|值为true和false显示上传附件|附件可以添加多个|
    |uploadAttachmentTitle|附件显示的名称|默认显示为"附件"|
    |   |前后置事件||
    |saveBeforeEvent|保存的前置事件|注意与按钮本身的前置事件区分|
    |saveAfterEvent|保存的后置事件|不论是否有后置事件，保存成功后都需要刷新面板|
    |beforeBSEvent|保存的B/S的前置事件|即后台处理的时候的前置事件|
    |afterBSEvent|保存的B/S的后置事件|即后台处理的时候的后置事件|
    |beforeServerEvent|服务端的前置事件|在主服务里处理的事件，有事务控制，可以随意操作数据.server端的前置事件需要加到主服务的运行环境中，一般不使用|
    |afterServerEvent|服务端的后置事件|在主服务里处理的事件，一般是多个业务功能有公共的处理部分是使用|
    |   |前后置事件的值使用标准的配置|jsPath#methodName?param=aaa&param1=bbb|

4. 文件字段的处理.不显示文档类型的下拉框。
   - 表单显示附件上传。需要配置uploadAttachment为true，页面会显示文件上传的组件，从上传的返回结果中获取到oid的属性，然后保存的时候把这个oid放到releaseFileOids
   - 有文件路径的字段。该字段显示为文件上传，只能一个。上传后，从返回结果中获取filePath，存储到这个字段上。
5. 保存时需要提交的参数。需要转换为json字符串的方式提交
   - 隐藏属性表示不需要单独处理，它是在表单加载或者是从来源数据里获取的，不会显示
     |参数名字|参数说明|参数示例和取值|
     |:--:|:--:|:--:|
     | |下方是跟配置和文件相关的||
     |formDefineId|表单的定义Id，必输|等于按钮的参数中的form属性；或者是UI上下文中的formDefineVO|
     |preEvent|前置事件|按钮参数上的beforeBSEvent|
     |afterEvent|后置事件|按钮参数上的afterBSEvent|
     |beforeServerEvent|服务端的前置事件|来源于按钮的参数|
     |afterServerEvent|服务端的后置时间|来源于按钮的参数|
     |releaseFileOids|附件的文件对象主键|数组的形式。比如 releaseFileOids=["111","222"]|
     | |下方全部是数据的属性||
     |oid|主键|修改的时候，这个值必输|
     |creator|创建人|用户的账号|
     |createTime|创建时间|时间类型，需要yyyy-MM-dd HH:mm:ss|
     |lastModifier|最后时间|用户的账号|
     |lastModifyTime|最后修改时间|时间类型，需要yyyy-MM-dd HH:mm:ss|
     |f_oid|from端的主键|即是from端数据的oid。direction不是true时，必输|
     |f_revisionoid|from的版本主键|即是from端数据里的revisionOid|
     |f_nameoid|from端的对象主键|即是from端数据里的nameoid|
     |f_btwname|from端的业务类型|即是from端数据里的btmname|
     |t_oid|to端的主键|即是to端数据的oid。direction为true时，必输|
     |t_revisionoid|to的版本主键|即是to端数据里的revisionOid|
     |t_nameoid|to端的对象主键|即是to端数据里的nameoid|
     |t_btwname|to端的业务类型|即是to端数据里的btmname|
     |ts|时间戳|不要改这个值，表单读取到的是多少，就返回多少，yyyy-MM-dd HH:mm:ss.SSS|]
     |data|其他的属性，就是除了上面的属性以外，都传递到这个属性里|这个是map的形式，转换为json字符串之前，是{xxxx:yyyy,zzz:aaa}这样的形式|
   - 示例
    ```
        //添加
        {
            "formDefineId":"11111",
            "oid":"",
            "f_oid":"22222",
            "f_btwname":"test",
            "data":{
                "attr1":"第一个属性的值",
                "attr2":"第二个属性的值",
                "attr3":3,
                "attr4":"2021-01-01 12:12:12"
            },
            "releaseFileOids":["222","333","444"]
         } 
        //修改
         {
             "formDefineId":"11111",
             "oid":"11111111111",
             "f_oid":"22222",
             "f_btwname":"test",
             "data":{
                 "attr1":"第一个属性的值",
                 "attr2":"第二个属性的值",
                 "attr3":3,
                 "attr4":"2021-01-01 12:12:12"
             },
             "releaseFileOids":["222","333","444"]
          } 
   ```  
6. 文件上传的参数处理
  - 路径 vciFileUploadController/uploadFile
  - 参数
     |参数名字|参数说明|参数示例和取值|
     |:--:|:--:|:--:|
     |file|文件组件里<input type="file" name="file"/>的名称|不能修改，哪怕表单里有多个文件类型的字段|
     |id|文件的显示名称|一般不输入，默认的是选择的文件的名称|
     |fileDocClassify|文档的使用类型|附件的时候，使用attachment;文件路径的类型的字段时，使用filePathField;|
     |fileDocClassifyName|文档的使用类型名称|附件的时候，使用"附件";文件路径的类型的字段时，使用"文件路径字段";|
     |secretGrade|密级|如果表单上有密级字段显示的时候，文件上传的组件的才显示密级，且文件的密级<=数据的密级|
     |updateFileFlag|是否为修改，true表示为修改|需要和oid配合使用|
     |fileOid|文件的主键|只在更新的时候才传递。如果是文件主键类型的字段时，就是这个字段的值，否则会在表单的加载数据中获取到|
7. 使用content的方式显示的页面的保存处理逻辑
  - 支持的场景
     |场景|场景说明|
     |:--:|:--:|
     |表单加特殊表达的页面|比如增加表单的某个字段的预览等，这些效果全部是跟表单相关的。这种可以将特殊的页面使用自定义组件完成|
8. 支持的场景
  - 修改的时候，链接类型和to端的数据也一样修改
     
   
     
