#弹出窗口查看详情
所有通用的按钮的js都存放在platform/actions下
1. js名称：BaseViewAction
2. 功能作用。
   - 弹出窗口显示数据的信息，全部都是只读的
   - 支持UI上下文和form两种方式
3. 参数的使用
    |参数名字|参数说明|参数示例|
    |:--:|:--:|:--:|
    |type|业务类型|如果参数没有配置这个属性，默认就等于这个按钮所在的组件所属的业务类型|
    |form|表单的英文名字|如果设置了form就不显示UI上下文。获取表单的路径为webUIController/getFormDefineById。btmType: 业务类型，值是按钮的参数中的type；id: 表单的英文名称，值是按钮的参数中的form|
    |content|UI上下文的名字，优先级小于form|
    |customPanel|自定义的页面，优先级小于content|即直接显示自定义的js的内容|
    |customIsMultiPanel|自定义页面是否为多用途组件|默认为false|
    |getDataUrl|获取数据的路径|默认为uiDataController/dataFormQuery|
    |getDataBackPath|获取数据的服务|默认为兼容性为true时等于path,否则为objectServicePath。即configData.compatibility?path:configData.objectServicePath|
    |getDataMethod|获取数据的方法类型|默认为get|
    |title|窗口的标题|form不为空则使用form的标题；否则使用UI上下文的时必须要配置。支持${xxx}和sourceData.${xxx}表达式|
    |width|窗口的宽度|默认是由layer自适应的|
    |height|窗口的高度|默认是由layer自适应的|
    |displayButton|是否显示按钮，只有在content有值，而form没有值的时候才使用|默认为false|
    |onlyField|字段显示为字段，在content和form时都生效|默认为true|
    |   |附件查看| |
    |uploadFileUrl| 文件上传的路径|默认为vciFileUploadController/uploadFile|
    |uploadFileBackPath|文件上传的服务名称| 默认为兼容性为true时等于path，否则为fileServicePath|
    |displayAttachment|值为true和false显示附件|附件可以添加多个,只能下载，不能上传|
    |displayAttachmentTitle|附件显示的名称|默认显示为"附件"|
    |   |前后置事件||
    |beforeEvent|显示的前置事件||
    |afterEvent|窗口关闭的后置事件||
    |   |前后置事件的值使用标准的配置|jsPath#methodName?param=aaa&param1=bbb|
    |   |其他的自定义参数||
    |   |除了以上的参数，其余自行扩展的参数，在content有值的情况下，作为sourceData传递到页面中|
4. 获取数据
   - 根据getDataUrl参数来调用后台.
   - 参数
       |参数名字|参数说明|参数示例|
       |:--:|:--:|:--:|
       |btmname|业务类型|可以从数据里获取,也可以是按钮上定义的type参数|
       |oid|主键|从选择的数据中获取|
       |formDefineId|表单的定义编号|form参数|
       |sourceDataMap|来源数据|按钮所属的区域的来源数据|
   -返回值
       ```
         "data":{
               ... 这里是对象的值的信息
          },
         "attachmentFileVOs":[{
                "oid:"文件的主键",
                "id":"文件的显示名称，不含后缀",
                "name":"文件的真实名称，不含后缀",
                "fileExtension":"文件的后缀名",
                "fileDocClassify":"文档类型",
                "fileDocClassifyName":"文档类型的名称",
                "fileSize":"文件的大小",
                "downloadCount":"下载次数",
                "filePath":"文件在卷文件夹里存放的路径"
            }] ,
         "filePathFieldMap":{
               "field这个是字段的名称":{
                    "oid:"文件的主键",
                     "id":"文件的显示名称，不含后缀",
                     "name":"文件的真实名称，不含后缀",
                     "fileExtension":"文件的后缀名",
                     "fileDocClassify":"文档类型",
                     "fileDocClassifyName":"文档类型的名称",
                     "fileSize":"文件的大小",
                     "downloadCount":"下载次数",
                     "filePath":"文件在卷文件夹里存放的路径"
               }
         }   
       ```     
     
   
     
